/*
 * MouseInputListeners.java
 *
 * Created on 30 de abril de 2007, 09:26 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

import java.awt.event.*;
import java.awt.Point;
/**
 *
 * @author Francisco Olivares
 * @author Cristhoper Jana
 */
public class MouseInputListeners implements MouseListener{
    private static InfoInterfaz informacionLabel;
    private static ListaDeLineasInterfaz listaDeLineasInterfaz;
    private static PanelInterfaz PanelGraficoInterfaz;
    protected static Point puntoInicial;
    private Point puntoFinal;
    /** Creates a new instance of MouseInputListeners */
    public MouseInputListeners() {
    }
    public static void setInfoInterfaz(InfoInterfaz informacionLabel_) {
        informacionLabel = informacionLabel_;
    }
    public static void setListaDeLineasInterfaz(ListaDeLineasInterfaz inter) {
        listaDeLineasInterfaz = inter;
    }
    public static void setPanelGraficoInterfaz(PanelInterfaz inter) {
        PanelGraficoInterfaz = inter;
    }
    public void mouseClicked(MouseEvent event) {
        puntoInicial = new Point(event.getX(),event.getY());
        if(MenusListeners.opcionActual != MenusListeners.TRASLADAR &&
                    MenusListeners.opcionActual != MenusListeners.ROTAR)
            informacionLabel.setLabelText("click: ("+event.getX()+","+
                                    event.getY()+")");
        if(listaDeLineasInterfaz.contiene(event.getX(),event.getY()))
            switch(MenusListeners.opcionActual) {
                case MenusListeners.TRASLADAR:
                    //
                    // no hacer nada
                    //
                    break;
                case MenusListeners.ROTAR:
                    if(listaDeLineasInterfaz.contiene(event.getX(),
                                                      event.getY())) {
                        //
                        // implementa la rotacion -> ESTA IMPLEMENTADO
                        //
                        listaDeLineasInterfaz.tomarComponente(event.getX(),
                                                              event.getY());
                        listaDeLineasInterfaz.rotar();
                        listaDeLineasInterfaz.soltarComponente();
                        PanelGraficoInterfaz.repaint();
                    }
                    break;
            }
    }
    public void mouseEntered(MouseEvent event) {
    }
    public void mouseExited(MouseEvent event) {
    }
    public void mousePressed(MouseEvent event) {
        puntoInicial = new Point(event.getX(),event.getY());
        if(listaDeLineasInterfaz.contiene(event.getX(),event.getY()))
            switch(MenusListeners.opcionActual) {
                case MenusListeners.TRASLADAR:
                    listaDeLineasInterfaz.tomarComponente(event.getX(),
                            event.getY());
                    break;
                case MenusListeners.ROTAR:
                    //
                    // no hacer nada
                    //
                    break;
            }
    }
    public void mouseReleased(MouseEvent event) {
        puntoFinal = new Point(event.getX(),event.getY());
        if(MenusListeners.opcionActual != MenusListeners.TRASLADAR &&
                    MenusListeners.opcionActual != MenusListeners.ROTAR)
            informacionLabel.setLabelText("arrastrar suelto: ("+event.getX()+","
                                                +event.getY()+")");
        if(listaDeLineasInterfaz.tengoTomadaUnaComponente())
            switch(MenusListeners.opcionActual) {
                case MenusListeners.TRASLADAR:
                    listaDeLineasInterfaz.recargarComponenteTomadaConRespaldo();
                    int deltaX = (int)puntoFinal.getX() -
                            (int)puntoInicial.getX();
                    int deltaY = (int)puntoFinal.getY() -
                            (int)puntoInicial.getY();
                    listaDeLineasInterfaz.mover(deltaX, deltaY);
                    listaDeLineasInterfaz.soltarComponente();
                    PanelGraficoInterfaz.repaint();
                    break;
                case MenusListeners.ROTAR:
                    //
                    // no hacer nada
                    //
                    break;
            }
        listaDeLineasInterfaz.vaciaElArregloDeCirculosRadiales();
    }
}
